*DECK SAPIDF
      SUBROUTINE SAPIDF(IPSAP,IPEDIT,NG,ICAL,FNORM,REGFLX)
*
*-----------------------------------------------------------------------
*
*Purpose:
* store discontinuity factor information in the Saphyb.
*
*Copyright:
* Copyright (C) 2015 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* IPSAP   pointer to the Saphyb.
* IPEDIT  pointer to the edition object (L_EDIT signature).
* NG      number of condensed energy groups.
* ICAL    index of the current elementary calculation.
* FNORM   flux normalization factor.
* REGFLX  averaged flux in the complete geometry.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPSAP,IPEDIT,NG,ICAL
      REAL FNORM,REGFLX(NG)
*----
*  LOCAL VARIABLES
*----
      PARAMETER (MAXADF=10)
      CHARACTER DIRNAM*12,HADF(MAXADF)*8
      COMMON BASE(1)
*----
*  RECOVER DISCONTINUITY FACTOR INFORMATION FROM MACROLIB
*----
      CALL LCMSIX(IPEDIT,'MACROLIB',1)
      CALL LCMLEN(IPEDIT,'ADF',ILONG,ITYLCM)
      IF(ILONG.EQ.0) CALL XABORT('SAPIDF: MISSING ADF DIRECTORY IN EDI'
     1 //'TION OBJECT.')
      CALL LCMSIX(IPEDIT,'ADF',1)
      CALL LCMGET(IPEDIT,'NTYPE',NSURFD)
      IF(NSURFD.GT.MAXADF) CALL XABORT('SAPIDF: MAXADF OVERFLOW.')
      CALL SETARA(BASE,NSURFD*NG,ISURFL)
      CALL SETARA(BASE,NG,ISURF)
      CALL LCMGTC(IPEDIT,'HADF',8,NSURFD,HADF)
      DO I=1,NSURFD
        CALL LCMGET(IPEDIT,HADF(I),BASE(ISURF))
        DO IGR=1,NG
          BASE(ISURFL+(IGR-1)*NSURFD+I-1)=BASE(ISURF+IGR-1)*FNORM*1.0E13
        ENDDO
      ENDDO
      CALL RLSARA(BASE(ISURF))
      CALL LCMSIX(IPEDIT,' ',2)
      CALL LCMSIX(IPEDIT,' ',2)
*----
*  MOVE TO THE 'calc' DIRECTORY.
*----
      WRITE(DIRNAM,'(''calc'',I8)') ICAL
      CALL LCMSIX(IPSAP,DIRNAM,1)
      CALL LCMSIX(IPSAP,'outflx',1)
      CALL LCMPUT(IPSAP,'REGFLX',NG,2,REGFLX)
      CALL LCMPUT(IPSAP,'SURFLX',NSURFD*NG,2,BASE(ISURFL))
      CALL LCMSIX(IPSAP,' ',2)
      CALL LCMSIX(IPSAP,' ',2)
      CALL RLSARA(BASE(ISURFL))
*----
*  CREATE dummy 'outgeom' DIRECTORY.
*----
      CALL LCMSIX(IPSAP,'geom',1)
      CALL LCMSIX(IPSAP,'outgeom',1)
      CALL SETARA(BASE,NSURFD,ISURF)
      DO I=1,NSURFD
        BASE(ISURF+I-1)=1.0
      ENDDO
      CALL LCMPUT(IPSAP,'SURF',NSURFD,2,BASE(ISURF))
      CALL RLSARA(BASE(ISURF))
      CALL LCMSIX(IPSAP,' ',2)
      CALL LCMSIX(IPSAP,' ',2)
      RETURN
      END
